<?php
// Sécurité
define('OK',1);
// Configuration
include('config.php');
// Fonctions
include('fonctions.php');

//////////////////
// Autorisation //
//////////////////

// Accès aux professeurs, colleurs, élèves connectés uniquement
$mysqli = connectsql();
if ( !$autorisation )  {
  $titre = 'Notes de colles';
  $actuel = false;
  include('login.php');
}
elseif ( $autorisation < 2 )  {
  debut($mysqli,'Notes de colles','Vous n\'avez pas accès à cette page.',$autorisation,' ');
  $mysqli->close();
  fin();
}

////////////////////////////////////////
// Validation de la requête : matière //
////////////////////////////////////////

// Recherche de la matière concernée, variable $matiere
// Si $_REQUEST['cle'] existe, on la cherche dans les matières disponibles.
$resultat = $mysqli->query('SELECT id, cle, nom FROM matieres WHERE '.( ( $autorisation == 2 ) ? 'notes AND ' : '' )."FIND_IN_SET(id,'${_SESSION['matieres']}')");
if ( $resultat->num_rows )  {
  if ( !empty($_REQUEST) )  {
    while ( $r = $resultat->fetch_assoc() )
      if ( isset($_REQUEST[$r['cle']]) )  {
        $matiere = $r;
        break;
      }
  }
  $resultat->free();
  // Si aucune matière trouvée
  if ( !isset($matiere) )  {
    debut($mysqli,'Notes de colles','Mauvais paramètre d\'accès à cette page.',$autorisation,' ');
    $mysqli->close();
    fin();
  }
}
// Si aucune matière présentant son programme de colle n'est enregistrée
else  {
  debut($mysqli,'Notes de colles','Cette page ne contient aucune information.',$autorisation,' ');
  $mysqli->close();
  fin();
}

//////////////////////////////////
// Exportation des notes en xls //
//////////////////////////////////
// Exportation uniquement si aucun header déjà envoyé
if ( ( $autorisation == 4 ) && isset($_REQUEST['xls']) && !headers_sent() )  {
  // Recherche des notes concernées
  $resultat = $mysqli->query("SELECT nom, GROUP_CONCAT( IFNULL(note,'') ORDER BY sid SEPARATOR '|') AS notes
                              FROM ( SELECT s.id AS sid, u.id AS eid, IF(LENGTH(nom),CONCAT(nom,' ',prenom),CONCAT(login,' (identifiant)')) AS nom
                                     FROM semaines AS s LEFT JOIN utilisateurs AS u ON 1 WHERE colle AND u.autorisation=2 ORDER BY IF(LENGTH(nom),nom,login)) AS t
                              LEFT JOIN notes ON sid = semaine AND eid = eleve AND matiere = ${matiere['id']} GROUP BY eid ORDER BY nom,sid");
  if ( $resultat->num_rows )  {
    // Fonctions de saisie
    function saisie_nombre($l, $c, $v)  {
      echo pack("sssss", 0x203, 14, $l, $c, 0).pack("d", $v);
      return;
    }
    function saisie_chaine($l, $c, $v)  {
      echo pack("ssssss", 0x204, 8 + strlen($v), $l, $c, 0, strlen($v)).$v;
      return;
    }
    // Envoi des headers
    header("Content-Type: application/vnd.ms-excel");
    header("Content-Disposition: attachment; filename=notes.xls");
    header("Content-Transfer-Encoding: binary");
    // Début du fichier xls
    echo pack("sssss", 0x809, 6, 0, 0x10, 0);
    // Remplissage
    $i = 0;
    $semaines = $mysqli->query('SELECT DATE_FORMAT(debut,\'%d/%m\') FROM semaines WHERE colle');
    while ( $r = $semaines->fetch_row() )
      saisie_chaine(0, ++$i, $r[0]);
    $semaines->free();
    $i = 0;
    while ( $r = $resultat->fetch_assoc() )  {
      saisie_chaine(++$i, 0, utf8_decode($r['nom']));
      $notes = explode('|',$r['notes']);
      foreach ( $notes as $j => $n)
        if ( is_numeric($n) )
          saisie_nombre($i, $j+1, $n);
        elseif ( strlen($n) )
          saisie_chaine($i, $j+1, $n);
    }
    // Fin du fichier xls
    echo pack("ss", 0x0A, 0x00);
    $resultat->free();
    $mysqli->close();
    exit();
  }
}

////////////
/// HTML ///
////////////
debut($mysqli,"Notes de colles - ${matiere['nom']}",$message,$autorisation,"notes?${matiere['cle']}");

// Affichage pour les élèves
if ( $autorisation == 2 )  {
  
  // Récupération de l'ensemble des notes, semaines, colleurs
  $resultat = $mysqli->query("SELECT DATE_FORMAT(s.debut,'%w%Y%m%e') AS d, n.note,
                              IF(LENGTH(u.nom),u.nom,u.login) AS colleur
                              FROM notes AS n LEFT JOIN semaines AS s ON n.semaine=s.id LEFT JOIN utilisateurs AS u ON n.colleur=u.id
                              WHERE n.eleve = ${_SESSION['id']} AND n.matiere = ${matiere['id']} ORDER BY s.id");

  // Affichage des notes concernées
  if ( $resultat->num_rows )  {
    while ( $r = $resultat->fetch_assoc() )
      echo '<article><h3>Semaine du '.format_date($r['d'])."</h3><p>${r['note']} (${r['c']})</p></article>\n\n";
    $resultat->free();
  }
  else
    echo "<article><h2>Vous n'avez encore aucune note en ${matiere['nom']} cette année.</h2></article>\n\n";

}

// Affichage colleur et professeur
else  {

  // Professeur : Visibilité du tableau global
  if ( $autorisation == 4 )  {
    // Icônes d'actions générales
    echo <<<FIN
  
  <a class="icon-aide general" data-id="page" title="Aide pour les modifications des programmes de colles"></a>
  <a class="icon-voirtout general" href="?${matiere['cle']}&amp;tableau" title="Voir le tableau de notes"></a>
  <a class="icon-download general" href="?${matiere['cle']}&amp;xls"></a>
  <a class="icon-ajoute general" data-id="ajoute" title="Ajouter des notes de colles"></a>

FIN;

    // Tableau récapitulatif
    if ( isset($_REQUEST['tableau']) )  {
      // Récupération des colleurs
      $resultat = $mysqli->query("SELECT id, IF(LENGTH(nom),CONCAT(prenom,' ',nom),CONCAT(login,' (identifiant)')) AS nom
                                  FROM utilisateurs WHERE autorisation > 2 AND FIND_IN_SET(${matiere['id']},matieres) ORDER BY IF(LENGTH(nom),nom,login)");
      $select_colleurs = '';
      while ( $r = $resultat->fetch_assoc() )
        $select_colleurs .= "\n      <option value=\"${r['id']}\">${r['nom']}</option>";
      $resultat->free();
      // Barre de sélection
      echo <<<FIN
  <p id="recherchenote" class="topbarre">
    Voir les notes de <select id="colleurs" onchange="if (this.value>0) { $('[data-colleur]').attr('class','collnosel'); $('[data-colleur=&quot;'+this.value+'&quot;]').attr('class','collsel'); } else $('[data-colleur]').removeClass();">
      <option value="0">tous les colleurs</option>$select_colleurs
    </select>
    <a class="icon-ferme" title="Fermer le tableau" href="?${matiere['cle']}"></a>
  </p>

FIN;
      // Recherche des notes concernées
      $resultat = $mysqli->query("SELECT nom, GROUP_CONCAT( IF(ISNULL(note),'<td></td>',CONCAT('<td data-colleur=\"',colleur,'\">',note,'</td>')) ORDER BY sid SEPARATOR '') AS notes
                                  FROM ( SELECT s.id AS sid,  u.id AS eid, CONCAT('<td>',IF(LENGTH(nom),CONCAT(nom,' ',prenom),CONCAT(login,' (identifiant)')),'</td>') AS nom
                                         FROM semaines AS s LEFT JOIN utilisateurs AS u ON 1 WHERE colle AND u.autorisation=2 ORDER BY IF(LENGTH(nom),nom,login)) AS t
                                  LEFT JOIN notes ON sid = semaine AND eid = eleve AND matiere = ${matiere['id']} GROUP BY eid ORDER BY nom,sid");
      if ( $resultat->num_rows )  {
        echo "  <table>\n    <thead>\n      <tr><th class=\"semaines\">Nom</th>";
        $semaines = $mysqli->query('SELECT DATE_FORMAT(debut,\'%d/%m\') FROM semaines WHERE colle');
        $nb = $semaines->num_rows;
        while ( $r = $semaines->fetch_row() )
          echo "<td class=\"semaines\"><span>${r[0]}</span></td>";
        $semaines->free();
        echo "</tr>\n    </thead>\n      <tbody>\n";
        while ( $r = $resultat->fetch_assoc() )
          if ( strlen(str_replace('<td></td>','',$r['notes'])) )
            echo "        <tr>${r['nom']}${r['notes']}</tr>\n";
          else
            echo "        <tr>${r['nom']}<td class=\"pasnote\" colspan=\"$nb\">Pas encore de note pour cet élève</td></tr>\n";
        $resultat->free();
        echo "      </tbody>\n  </table>\n\n";
      }
      else
        echo "<article><h2>Il n'y a encore aucune note de colle en ${matiere['nom']} cette année.</h2></article>\n\n";
    }
  }
  else
    echo <<<FIN
  
  <a class="icon-aide general" data-id="page" title="Aide pour les modifications des programmes de colles"></a>
  <a class="icon-ajoute general" data-id="ajoute" title="Ajouter des notes de colles"></a>

FIN;

  // Récupération de l'ensemble des élèves (associés à la matière)
  $resultat = $mysqli->query("SELECT id, IF(LENGTH(nom),CONCAT(nom,' ',prenom),CONCAT(login,' (identifiant)')) AS nom
                              FROM utilisateurs WHERE autorisation = 2 AND FIND_IN_SET(${matiere['id']},matieres) ORDER BY IF(LENGTH(nom),nom,login)");
  $eleves = array();
  while ( $r = $resultat->fetch_assoc() )
    $eleves[$r['id']] = $r['nom'];
  $resultat->free();

  // Récupération de l'ensemble des semaines
  $resultat = $mysqli->query("SELECT s.id, DATE_FORMAT(debut,'%w%Y%m%e') AS debut, colle, vacances, IFNULL(GROUP_CONCAT(n.eleve),'') AS eleves, COUNT(n.id) AS n
                              FROM semaines AS s LEFT JOIN (SELECT * FROM notes WHERE matiere = ${matiere['id']} AND colleur=${_SESSION['id']}) AS n ON s.id = n.semaine GROUP BY s.id");
  $select_semaines = "\n      <option value=\"0\">Choisir une semaine</option>";
  $semaines = $semaines_notes = array();
  while ( $r = $resultat->fetch_assoc() )  {
    switch ( $r['vacances'] )  {
      case 0:
        if ( $r['colle'] == 0 )
          $select_semaines .= "\n      <option disabled>".format_date($r['debut']).' (pas de colle)</option>';
        elseif ( $r['n'] )  {
          $select_semaines .= "\n      <option disabled>".format_date($r['debut'])." (${r['n']} notes déjà entrées)</option>";
          $semaines[$r['id']] = $r['debut']; 
          $semaines_notes[$r['id']] = $r['eleves']; 
        }
        else  {
          $select_semaines .= "\n      <option value=\"${r['id']}-${matiere['id']}\">".format_date($r['debut']).'</option>';
          $semaines_notes[$r['id']] = $r['eleves']; 
        }
        break;
      case 1:
        $select_semaines .= "\n      <option disabled>Vacances de Toussaint</option>";
        break;
      case 2:
        $select_semaines .= "\n      <option disabled>Vacances de Noël</option>";
        break;
      case 3:
        $select_semaines .= "\n      <option disabled>Vacances d'hiver</option>";
        break;
      case 4:
        $select_semaines .= "\n      <option disabled>Vacances de Pâques</option>";
    }
  }
  $resultat->free();
  
  // Récupération de l'ensemble des notes mises, regroupées par semaine
  $resultat = $mysqli->query("SELECT semaine, COUNT(id) AS nb,
                              GROUP_CONCAT(eleve ORDER BY id SEPARATOR '|') AS eleves, GROUP_CONCAT(note ORDER BY id SEPARATOR '|') AS notes
                              FROM notes WHERE colleur = ${_SESSION['id']} AND matiere = ${matiere['id']} GROUP BY semaine ORDER BY semaine DESC");
  // Affichage de l'ensmeble des notes de l'année
  if ( $resultat->num_rows )  {
    while ( $r = $resultat->fetch_assoc() )  {
      $date = format_date($semaines[$r['semaine']]);
      $notes = array_combine(explode('|',$r['eleves']),explode('|',$r['notes']));
      $n = count($notes);
      $texte = array();
      foreach( $notes as $e => $n ) {
        $texte[] = "${eleves[$e]} ($n)";
      }
      $texte = implode(', ',$texte);
      echo <<<FIN
  <article data-id="notes|${r['semaine']}-${matiere['id']}">
    <h3 class="edition">Semaine du $date</h3>
    <a class="icon-supprime" title="Supprimer ces notes"></a>
    <a class="icon-edite" title="Modifier ces notes" data-id="notes" data-eleves="${r['eleves']}" data-notes="${r['notes']}" onclick="formulaire(this);"></a>
    <p><strong>${r['nb']} notes&nbsp;:</strong> $texte</p>
  </article>
FIN;
    }
    $resultat->free();
  }
  else
    echo "<article><h2>Vous n'avez encore saisi aucune note en ${matiere['nom']} cette année.</h2></article>\n\n";

  // Aide et formulaire d'ajout

  // Table contenant les élèves
  $table = '';
  foreach ( $eleves as $id => $eleve )  {
    $table .= "        <tr data-id=\"$id\"><td>$eleve</td><td></td></tr>\n";
  }
  // Récupération des groupes de colles et préparation à l'affichage
  $resultat = $mysqli->query("SELECT g.id, g.nom, GROUP_CONCAT(e.id) AS eid,
                              GROUP_CONCAT( IF(LENGTH(e.nom),CONCAT(e.prenom,' ',e.nom),CONCAT(e.login,' (identifiant)')) ORDER BY IF(LENGTH(e.nom),e.nom,e.login) SEPARATOR ', ') AS eleves
                              FROM groupes AS g JOIN utilisateurs AS e ON FIND_IN_SET(e.id,g.eleves)
                              WHERE g.mailnotes>1 AND FIND_IN_SET(${matiere['id']},e.matieres) GROUP BY g.id ORDER BY g.nom_nat");
  if ( $resultat->num_rows )  {
    $table .= "    <tr><th>Groupes de colles</th><th></th></tr>\n";
    while ( $r = $resultat->fetch_assoc() )
      $table .= "        <tr><td>Groupe ${r['nom']}&nbsp;: ${r['eleves']}</td><td><input type=\"checkbox\" class=\"grpnote\" value=\"${r['eid']}\"></td></tr>\n";
    $resultat->free();
  }
?>

  <script type="text/javascript">
    dejanotes = $.parseJSON('<?php echo json_encode($semaines_notes); ?>');
  </script>

  <form id="form-notes">
    <h3 class="edition">Modifier des notes de colles</h3>
    <h4></h4>
    <table id="notes">
      <tbody>
<?php echo $table; ?>
      </tbody>
    </table>
    <div><select><option value="x"></option><option value="7">7</option><option value="8">8</option><option value="9">9</option><option value="10">10</option><option value="11">11</option><option value="12">12</option><option value="13">13</option><option value="14">14</option><option value="15">15</option><option value="16">16</option><option value="17">17</option><option value="18">18</option><option value="19">19</option><option value="20">20</option><option value="abs">Absent</option><option value="0">0</option><option value="1">1</option><option value="2">2</option><option value="3">3</option><option value="4">4</option><option value="5">5</option><option value="6">6</option><option value="0,5">0,5</option><option value="1,5">1,5</option><option value="2,5">2,5</option><option value="3,5">3,5</option><option value="4,5">4,5</option><option value="5,5">5,5</option><option value="6,5">6,5</option><option value="7,5">7,5</option><option value="8,5">8,5</option><option value="9,5">9,5</option><option value="10,5">10,5</option><option value="11,5">11,5</option><option value="12,5">12,5</option><option value="13,5">13,5</option><option value="14,5">14,5</option><option value="15,5">15,5</option><option value="16,5">16,5</option><option value="17,5">17,5</option><option value="18,5">18,5</option><option value="19,5">19,5</option></select></div>
    <input type="hidden" name="id" value="">
    <input type="hidden" name="notes" value="">
  </form>

  <form id="form-ajoute">
    <h3 class="edition">Ajouter des notes de colles</h3>
    <p class="ligne"><label for="semaine">Semaine</label>
      <select id="semaine" name="id"><?php echo $select_semaines; ?>
      </select>
    </p>
    <table id="notes">
      <tbody>
<?php echo $table; ?>
      </tbody>
    </table>
    <div><select><option value="x"></option><option value="7">7</option><option value="8">8</option><option value="9">9</option><option value="10">10</option><option value="11">11</option><option value="12">12</option><option value="13">13</option><option value="14">14</option><option value="15">15</option><option value="16">16</option><option value="17">17</option><option value="18">18</option><option value="19">19</option><option value="20">20</option><option value="abs">Absent</option><option value="0">0</option><option value="1">1</option><option value="2">2</option><option value="3">3</option><option value="4">4</option><option value="5">5</option><option value="6">6</option><option value="0,5">0,5</option><option value="1,5">1,5</option><option value="2,5">2,5</option><option value="3,5">3,5</option><option value="4,5">4,5</option><option value="5,5">5,5</option><option value="6,5">6,5</option><option value="7,5">7,5</option><option value="8,5">8,5</option><option value="9,5">9,5</option><option value="10,5">10,5</option><option value="11,5">11,5</option><option value="12,5">12,5</option><option value="13,5">13,5</option><option value="14,5">14,5</option><option value="15,5">15,5</option><option value="16,5">16,5</option><option value="17,5">17,5</option><option value="18,5">18,5</option><option value="19,5">19,5</option></select></div>
    <input type="hidden" name="notes" value="">
  </form>
  
  <div id="aide-page">
    <h3>Aide et explications</h3>
    <p>À venir bientôt...</p>
  </div>

  <div id="aide-notes">
    <h3>Aide et explications</h3>
    <p>À venir bientôt...</p>
  </div>

  <div id="aide-ajoute">
    <h3>Aide et explications</h3>
    <p>À venir bientôt...</p>
  </div>
  
  <p id="log"></p>

<?php
}

$mysqli->close();
fin($autorisation>2);
?>
