<?php
// Sécurité
define('OK',1);
// Configuration
include('config.php');
// Fonctions
include('fonctions.php');

// Compte demandés en attente de validation de l'équipe pédagogique :
// @ devant mail (pour empêcher la récupération de mdp par mail), * devant mdp
// Compte proposés en attente de réponse de l'utilisateur : mdp = '*'
// => Pour les différentier, utiliser la longueur du mdp (1, 40, 41).

//////////////////
// Autorisation //
//////////////////

// Accès aux professeurs connectés uniquement
$mysqli = connectsql();
if ( !$autorisation )  {
  $titre = 'Modification des utilisateurs';
  $actuel = false;
  include('login.php');
}
elseif ( $autorisation < 4 )  {
  debut($mysqli,'Modification des utilisateurs','Vous n\'avez pas accès à cette page.',$autorisation,' ');
  $mysqli->close();
  fin();
}

//////////////
//// HTML ////
//////////////
debut($mysqli,'Modification des utilisateurs',$message,4,'utilisateurs');
echo <<<FIN

  <a class="icon-aide general" data-id="page" title="Aide pour les modifications des utilisateurs"></a>
  <a class="icon-prefs general" data-id="prefs" title="Modifier les réglages de la gestion des comptes"></a>
  <a class="icon-ajoute general" data-id="ajoute" title="Ajouter de nouveaux utilisateurs"></a>

  <article>
    <h3>Liste des utilisateurs</h3>
    <table>
      <tbody>

FIN;

$autorisations = array(1=>'Invité',2=>'Élève',3=>'Colleur',4=>'Professeur');

// Récupération des demandes à valider
$resultat = $mysqli->query('SELECT id, IF(LENGTH(mail),SUBSTR(mail,2),"Pas de mail") AS mail, autorisation, CONCAT( nom, \' \', prenom ) AS nom
                            FROM utilisateurs WHERE LENGTH(mdp)=41 ORDER BY IF(LENGTH(nom),CONCAT(nom,prenom),login)');
if ( $n = $resultat->num_rows )  {
  $n = ( $n > 1 ) ? "$n comptes" : "1 compte";
  echo "        <tr><th colspan=\"5\">En attente de validation ($n)</th></tr>\n";
  while ( $r = $resultat->fetch_assoc() )
    echo "        <tr><td colspan=\"4\">${r['nom']} - ${r['mail']} - ".$autorisations[$r['autorisation']]."</td><td data-id=\"utilisateurs|${r['id']}\"><a class=\"icon-supprime\" title=\"Supprimer ce compte\"> <a class=\"icon-ajoute\" title=\"Valider ce compte\"></a></td></tr>\n";
  $resultat->free();
}

// Récupération des invitations non répondues
$resultat = $mysqli->query('SELECT id, IF(LENGTH(mail),mail,"Pas de mail") AS mail, autorisation, CONCAT( nom, \' \', prenom ) AS nom
                            FROM utilisateurs WHERE LENGTH(mdp)=1 ORDER BY IF(LENGTH(nom),CONCAT(nom,prenom),login)');
if ( $n = $resultat->num_rows )  {
  $n = ( $n > 1 ) ? "$n comptes" : "1 compte";
  echo "        <tr><th colspan=\"5\">Invitations envoyées ($n)</th></tr>\n";
  while ( $r = $resultat->fetch_assoc() )
    echo "        <tr><td colspan=\"4\">${r['nom']} - ${r['mail']} - ".$autorisations[$r['autorisation']]."</td><td data-id=\"utilisateurs|${r['id']}\"><a class=\"icon-supprime\" title=\"Supprimer ce compte\"></a></td></tr>\n";
  $resultat->free();
}

// Décompte total des utilisateurs (comptes validés) en fonction de leur type
$resultat = $mysqli->query('SELECT autorisation, COUNT(id) AS n FROM utilisateurs WHERE LENGTH(mdp)=40 GROUP BY autorisation ORDER BY autorisation DESC');
$n = array();
while ( $r = $resultat->fetch_assoc() )
  $n[$r['autorisation']] = ( $r['n'] > 1 ) ? "${r['n']} comptes" : "${r['n']} compte";
$resultat->free();

// Récupération des utilisateurs
$resultat = $mysqli->query('SELECT id, nom, prenom, login, mail, autorisation
                            FROM utilisateurs WHERE LENGTH(mdp)=40 ORDER BY autorisation DESC, IF(LENGTH(nom),CONCAT(nom,prenom),login)');
$a = 0;
while ( $r = $resultat->fetch_assoc() )  {
  if ( $a != $r['autorisation'] )  {
    $a = $r['autorisation'];
    switch ( $a )  {
      case 1 : $t = 'Invités'; break;
      case 2 : $t = 'Élèves'; break;
      case 3 : $t = 'Colleurs'; break;
      case 4 : $t = 'Professeurs'; break;
    }
    echo <<<FIN
        <tr><th colspan="5">$t (${n[$a]})</th></tr>
        <tr><th>Nom</th><th>Prénom</th><th>Identifiant</th><th>Mail</th><th></th></tr>

FIN;
  }
  if ( $a > 1 )
    echo "<tr><td class=\"editable\" data-id=\"utilisateurs|nom|${r['id']}\">${r['nom']}</td><td class=\"editable\" data-id=\"utilisateurs|prenom|${r['id']}\">${r['prenom']}</td><td>${r['login']}</td><td class=\"editable\" data-id=\"utilisateurs|mail|${r['id']}\">${r['mail']}</td><td data-id=\"utilisateurs|${r['id']}\"><a class=\"icon-supprime\" title=\"Supprimer ce compte\"></a></td></tr>\n";
  else
    echo "<tr><td></td><td></td><td>${r['login']}</td><td></td><td data-id=\"utilisateurs|${r['id']}\"><a class=\"icon-supprime\" title=\"Supprimer ce compte\"></a></td></tr>\n";
}
?>
      </tbody>
    </table>
  </article>

<?php
// Récupération des matières
$resultat = $mysqli->query('SELECT id, nom FROM matieres');
$select_matieres = '';
while ( $r = $resultat->fetch_assoc() )
  $select_matieres .= "\n          <option value=\"${r['id']}\">${r['nom']}</option>";
$resultat->free();

// Récupération du réglage "création impossible"
$resultat = $mysqli->query('SELECT id FROM utilisateurs WHERE LENGTH(mdp) = 0');
if ( $creationinterdite = $resultat->num_rows )
  $resultat->free();

// Aide et formulaire d'ajout
?>

  <form id="form-ajoute">
    <h3 class="edition">Ajouter de nouveaux utilisateurs</h3>
    <p class="ligne"><label for="autorisation">Type de comptes&nbsp;:</label>
      <select name="autorisation" id="autorisation">
        <option value="1">Invités</option>
        <option value="2" selected>Élèves</option>
        <option value="3">Colleurs</option>
        <option value="4">Professeurs</option>
      </select>
    </p>
    <p class="ligne"><label for="matiere">Matière&nbsp;:</label>
      <select name="matiere" id="matiere">
        <option value="0">Toutes matières</option><?php echo $select_matieres; ?>
      </select>
    </p>
    <p class="ligne"><label for="utilisateurs">Comptes à créer&nbsp;:</label></p>
    <p>Écrire ci-dessous les nouveaux utilisateurs&nbsp;:</p>
    <ul>
      <li>Un utilisateur par ligne</li>
      <li>Uniquement des utilisateurs de même type à chaque envoi</li>
      <li>Pour chaque utilisateur de type élève, colleur ou professeur, deux possibilités :
        <ul style="margin: 0;">
          <li>3 valeurs séparées par des virgules&nbsp;: nom, prénom, mail</li>
          <li>3 valeurs séparées par des points-virgules&nbsp;: nom, prénom, mot de passe</li>
        </ul>
        Dans le premier cas, un mail sera envoyé à chaque utilisateur avec un lien pour générer le mot de passe. Dans le second cas, ce sera à vous de communiquer les mots de passe.
      </li>
      <li>Pour chaque compte invité, 2 valeurs séparées par des virgules&nbsp;: identifiant, mot de passe</li>
    </ul>
    <textarea id="utilisateurs" name="utilisateurs" rows="10" cols="100" data-placeholder="Comptes élèves ou colleurs ou professeurs :<br>Nom1,Prénom1,Mail1<br>Nom2,Prénom2,Mail2<br>...<br>Comptes invités :<br>Identifiant1,Motdepasse1<br>Identifiant2,Motdepasse2<br>..."></textarea>
    <input type="hidden" name="table" value="utilisateurs">
  </form>

  <form id="form-prefs">
    <h3 class="edition">Réglages de la gestion des comptes</h3>
    <p class="ligne"><label for="autoriser">Autoriser les demandes de création de comptes&nbsp;: </label>
      <input type="checkbox" id="autoriser" name="autoriser"<?php echo ( $creationinterdite ) ? '' : ' checked'; ?>>
    </p>
    <input type="hidden" name="creation" value="1">
    <input type="hidden" name="table" value="utilisateurs">
  </form>
  
  <div id="aide-page">
    <h3>Aide et explications</h3>
    <p>À venir bientôt...</p>
  </div>

  <div id="aide-ajoute">
    <h3>Aide et explications</h3>
    <p>À venir bientôt...</p>
  </div>
  
  <div id="aide-prefs">
    <h3>Aide et explications</h3>
    <p>À venir bientôt...</p>
  </div>


  <p id="log"></p>
  
<?php

$mysqli->close();
fin(true);
?>
